﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using System.Windows.Forms;
using System.IO;

namespace FDK
{
	public class C共通
	{
		public static void tIDisposableを解放する<T>( ref T obj )
		{
			if( obj == null )
				return;

			var d = obj as IDisposable;

			if( d != null )
				d.Dispose();

			obj = default( T );
		}
		public static void LogBlock( string str処理名, MethodInvoker method )
		{
			Trace.TraceInformation( "開始 - " + str処理名 );
			Trace.Indent();
			try
			{
				method();
			}
			finally
			{
				Trace.Unindent();
				Trace.TraceInformation( "終了 - "  + str処理名 );
			}
		}
		public static void t例外の詳細をログに出力する( Exception e )
		{
			Trace.WriteLine( "---例外ここから----" );
			Trace.WriteLine( e.ToString() );
			Trace.WriteLine( "---例外ここまで----" );
		}
		public static string t指定した拡張子を持つファイルを検索し最初に見つけたファイルの絶対パスを返す( string strフォルダパス, List<string> list拡張子リスト )
		{
			string[] files = Directory.GetFiles( strフォルダパス );		// GetFiles() は完全パスを返す。

			foreach( string file in files )
			{
				string fileExt = Path.GetExtension( file );
				
				if( fileExt != null )
				{
					foreach( string ext in list拡張子リスト )
					{
						if( fileExt.Equals( ext, StringComparison.OrdinalIgnoreCase ) )
							return file;		// あった
					}
				}
			}

			return null;	// なかった
		}

		public static void tXMLファイルを読み込む<T>( string strXMLファイル名, out T xmlObject )
		{
			FileStream fs = null;
			StreamReader sr = null;
			xmlObject = default( T );
			try
			{
				fs = new FileStream( strXMLファイル名, FileMode.Open );
				sr = new StreamReader( fs, Encoding.UTF8 );
				var xmlsl = new System.Xml.Serialization.XmlSerializer( typeof( T ) );
				xmlObject = (T) xmlsl.Deserialize( sr );
			}
			finally
			{
				if( sr != null )
					sr.Close();

				if( fs != null )
					fs.Close();
			}
		}
		public static void tXMLファイルを保存する<T>( string strXMLファイル名, T xmlObject )
		{
			FileStream fs = null;
			StreamWriter sw = null;
			try
			{
				fs = new FileStream( strXMLファイル名, FileMode.Create );
				sw = new StreamWriter( fs, Encoding.UTF8 );
				var xmlsl = new System.Xml.Serialization.XmlSerializer( typeof( T ) );
				xmlsl.Serialize( sw, xmlObject );
			}
			finally
			{
				if( sw != null )
					sw.Close();

				if( fs != null )
					fs.Close();
			}

		}
		
		public static double DegreeToRadian( double angle )
		{
			return ( ( Math.PI * angle ) / 180.0 );
		}
		public static double RadianToDegree( double angle )
		{
			return ( angle * 180.0 / Math.PI );
		}
		public static float DegreeToRadian( float angle )
		{
			return (float) DegreeToRadian( (double) angle );
		}
		public static float RadianToDegree( float angle )
		{
			return (float) RadianToDegree( (double) angle );
		}
	}
}
